"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var construct_1 = require('../construct');
var InspectionChecklistItemsApi = (function () {
    function InspectionChecklistItemsApi(construct) {
        this.construct = construct;
        this._basePath = '/v4/inspections';
    }
    InspectionChecklistItemsApi.prototype.buildPath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (!args) {
            return this._basePath;
        }
        return this._basePath + "/" + args.join('/');
    };
    // private buildChecklistItemPath(inspectionId, checklistId, checklistItemId) {
    //   return `/${inspectionId}/checklists/${checklistId}/checklistItems/${checklistItemId}`;
    // }
    InspectionChecklistItemsApi.prototype.checklistItemPath = function (inspectionId, checklistId, checklistItemId) {
        var slug = "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems/" + checklistItemId;
        var self = this;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i - 0] = arguments[_i];
            }
            return self.buildPath(slug, args);
        };
    };
    // GET /v4/inspections/{inspectionId}/checklists/{checklistId}/checklistItems
    InspectionChecklistItemsApi.prototype.get = function (inspectionId, checklistId, urlParams, headers) {
        return this.construct.get(this._basePath + "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems", urlParams, headers);
    };
    // GET /v4/inspections/{inspectionId}/checklists/{checklistId}/checklistItems/{checklistItemId}/statuses
    InspectionChecklistItemsApi.prototype.getStatuses = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        return this.construct.get(this._basePath + "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems/" + checklistItemId + "/statuses", urlParams, headers);
    };
    // GET /v4/inspections/{inspectionId}/checklists/{checklistId}/checklistItems/{checklistItemId}/histories
    InspectionChecklistItemsApi.prototype.getHistories = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        return this.construct.get(this._basePath + "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems/" + checklistItemId + "/histories", urlParams, headers);
    };
    // PUT /v4/inspections/ checklists / { id } / checklistItems
    InspectionChecklistItemsApi.prototype.update = function (checklistId, urlParams, headers) {
        return this.construct.get(this._basePath + "/" + checklistId + "/checklistItems", urlParams, headers);
    };
    // GET /v4/inspections/ { id } / checklists / { checklistId } / checklistItems / { checklistItemId } / customForms / meta
    InspectionChecklistItemsApi.prototype.getCustomForms = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        var path = this._basePath + "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems/" + checklistItemId + "/customForms/meta";
        return this.construct.get(path, urlParams, headers)
            .map(function (data) {
            return data.map(function (item) {
                item.fields.map(function (i) {
                    i.value = i.value || null;
                });
                return item;
            });
        });
    };
    InspectionChecklistItemsApi.prototype.getCustomForm = function (inspectionId, checklistId, checklistItemId, formId, urlParams, headers) {
        var path = this._basePath + "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems/" + checklistItemId + "/customForms/" + formId + "/meta";
        return this.construct.get(path, urlParams, headers);
    };
    // PUT /v4/inspections/ { id } / checklists / { checklistId } / checklistItems / { checklistItemId } / customForms
    InspectionChecklistItemsApi.prototype.updateCustomForm = function (inspectionId, checklistId, checklistItemId, body, urlParams, headers) {
        var path = this._basePath + "/" + inspectionId + "/checklists/" + checklistId + "/checklistItems/" + checklistItemId + "/customForms";
        return this.construct.update(path, body, urlParams, headers);
    };
    // GET /v4/inspections/{id}/checklists/{checklistId}/checklistItems/{checklistItemId}/customTables
    InspectionChecklistItemsApi.prototype.getCustomTables = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        var path = this.checklistItemPath(inspectionId, checklistId, checklistItemId);
        // let path = this.buildPath(inspectionId, 'checklists', checklistId, 'checklistItems', checklistItemId, 'customTables');
        return this.construct.get(path('customTables'), urlParams, headers);
    };
    // GET /v4/inspections/{id}/checklists/{checklistId}/checklistItems/{checklistItemId}/customTables/meta
    InspectionChecklistItemsApi.prototype.getCustomTablesMetaData = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        var path = this.buildPath(inspectionId, 'checklists', checklistId, 'checklistItems', checklistItemId, 'customTables', 'meta');
        return this.construct.get(path, urlParams, headers);
    };
    // GET /v4/inspections/{id}/checklists/{checklistId}/checklistItems/{checklistItemId}/customTables/{tableId}
    InspectionChecklistItemsApi.prototype.getCustomTable = function (inspectionId, checklistId, checklistItemId, tableId, urlParams, headers) {
        var path = this.buildPath(inspectionId, 'checklists', checklistId, 'checklistItems', checklistItemId, 'customTables', tableId);
        return this.construct.get(path, urlParams, headers);
    };
    // GET /v4/inspections/{id}/checklists/{checklistId}/checklistItems/{checklistItemId}/customTables/{tableId}/meta
    InspectionChecklistItemsApi.prototype.getCustomTableMetaData = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        var path = this.buildPath(inspectionId, 'checklists', checklistId, 'checklistItems', checklistItemId, 'meta');
        return this.construct.get(path, urlParams, headers);
    };
    // PUT /v4/inspections/{id}/checklists/{checklistId}/checklistItems/{checklistItemId}/customTables
    InspectionChecklistItemsApi.prototype.updateCustomTable = function (inspectionId, checklistId, checklistItemId, body, urlParams, headers) {
        var path = this.buildPath(inspectionId, 'checklists', checklistId, 'checklistItems', checklistItemId, 'customTables');
        return this.construct.update(path, body, urlParams, headers);
    };
    // GET /v4/inspections/{inspectionId}/checklists/{checklistId}/checklistItems/{checklistItemId}/documents
    InspectionChecklistItemsApi.prototype.getDocuments = function (inspectionId, checklistId, checklistItemId, urlParams, headers) {
        var path = this.checklistItemPath(inspectionId, checklistId, checklistItemId);
        return this.construct.get(path('documents'), urlParams, headers);
    };
    // POST /v4/inspections/{inspectionId}/checklists/{checklistId}/checklistItems/{checklistItemId}/documents
    InspectionChecklistItemsApi.prototype.addDocument = function (inspectionId, checklistId, checklistItemId, body, urlParams, headers) {
        var path = this.checklistItemPath(inspectionId, checklistId, checklistItemId);
        return this.construct.post(path('documents'), body, urlParams, headers);
    };
    InspectionChecklistItemsApi = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [construct_1.ConstructApi])
    ], InspectionChecklistItemsApi);
    return InspectionChecklistItemsApi;
}());
exports.InspectionChecklistItemsApi = InspectionChecklistItemsApi;
//# sourceMappingURL=checklist-items.js.map