import {Injectable} from '@angular/core';
import {Http, Headers, Response} from '@angular/http';
import {Observable} from 'rxjs/Observable';
import {ConstructApi} from '../construct';
import {ConstructHelpers} from '../helpers/helpers';

@Injectable()
export class InspectionChecklistsApi {
  private _basePath = '/v4/inspections';

  constructor(private construct: ConstructApi) { }

  // GET /v4/inspections/ { inspectionId } / checklists
  get(inspectionId:number, urlParams?, headers?) {
    // let path = ConstructHelpers.buildPath(this._basePath, inspectionId, 'checklists')
    return this.construct.get(`${this._basePath}/${inspectionId}/checklists`, urlParams, headers);
  }

  // POST /v4/inspections/ { inspectionId } / checklists
  create(inspectionId:number, body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/${inspectionId}/checklists`, body, urlParams, headers);
  }
}
