"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var construct_1 = require('../construct');
var InspectionConditionsApi = (function () {
    function InspectionConditionsApi(construct) {
        this.construct = construct;
        this._basePath = '/v4/inspections';
    }
    InspectionConditionsApi.prototype.conditionsPath = function (inspectionId, conditionId) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var remainder = args.join('/');
        return this._basePath + "/" + inspectionId + "/conditions/" + remainder;
    };
    //   GET /v4/inspections/{inspectionId}/conditions
    InspectionConditionsApi.prototype.getAll = function (inspectionId, urlParams, headers) {
        return this.construct.get(this._basePath + "/" + inspectionId + "/", urlParams, headers);
    };
    //   GET /v4/inspections/{inspectionId}/conditions/{id}
    InspectionConditionsApi.prototype.get = function (inspectionId, conditionId, urlParams, headers) {
        return this.construct.get(this.conditionsPath(inspectionId, conditionId), urlParams, headers);
    };
    // GET /v4/inspections/ { inspectionId } / conditions / { id } / histories
    InspectionConditionsApi.prototype.getHistory = function (inspectionId, conditionId, urlParams, headers) {
        return this.construct.get(this.conditionsPath(inspectionId, conditionId, 'histories'), urlParams, headers);
    };
    // PUT /v4/inspections/ { inspectionId } / conditions / { id }
    InspectionConditionsApi.prototype.update = function (inspectionId, conditionId, body, urlParams, headers) {
        return this.construct.update(this.conditionsPath(inspectionId, conditionId, 'histories'), body, urlParams, headers);
    };
    // DELETE /v4/inspections/{inspectionId}/conditions/{ids}
    InspectionConditionsApi.prototype.del = function (inspectionId, conditionId, urlParams, headers) {
        return this.construct.del(this.conditionsPath(inspectionId, conditionId, 'histories'), urlParams, headers);
    };
    // POST /v4/inspections/ { inspectionId } / conditions
    InspectionConditionsApi.prototype.create = function (inspectionId, body, urlParams, headers) {
        return this.construct.post(this._basePath + "/" + inspectionId + "/conditions", body, urlParams, headers);
    };
    InspectionConditionsApi = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [construct_1.ConstructApi])
    ], InspectionConditionsApi);
    return InspectionConditionsApi;
}());
exports.InspectionConditionsApi = InspectionConditionsApi;
//# sourceMappingURL=conditions.js.map