import {Injectable} from '@angular/core';
import {Http, Headers, Response} from '@angular/http';
import {Observable} from 'rxjs/Observable';
import {ConstructApi} from '../construct';

@Injectable()
export class InspectionDocumentsApi {
  private _basePath = '/v4/inspections';

  constructor(private construct: ConstructApi) { }

  private docsPath(inspectionId) {
    return `${this._basePath}/${inspectionId}/documents`;
  }

  get(inspectionId, urlParams?, headers?) {
    return this.construct.get(this.docsPath(inspectionId), urlParams, headers);
  }

  del(inspectionId, documentId, urlParams?, headers?) {
    return this.construct.del(`${this.docsPath(inspectionId)}/${documentId}`, urlParams, headers);
  }

  deleteDocuments(inspectionId, docs:Array<any>, urlParams?, headers?) {
    let args = docs.join(',');
    return this.construct.del(`${this.docsPath(inspectionId)}/${args}`, urlParams, headers);
  }

  create(inspectionId, body, urlParams?, headers?) {
    return this.construct.post(this.docsPath(inspectionId), body, urlParams, headers);
  }
}
