"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var construct_1 = require('../construct');
var InspectionApi = (function () {
    function InspectionApi(construct) {
        this.construct = construct;
        this._basePath = '/v4/inspections';
    }
    InspectionApi.prototype.search = function (opts, urlParams, headers) {
        return this.construct.search('/v4/search/inspections', opts, urlParams, headers);
    };
    // GET /v4/inspections
    InspectionApi.prototype.getAll = function (urlParams, headers) {
        return this.construct.get(this._basePath, urlParams, headers);
    };
    // PUT /v4/inspections/{ ids }/assign
    InspectionApi.prototype.assignInspections = function (ids, inspectorId, params, headers) {
        var args = ids.join(',');
        var path = this._basePath + "/" + args + "/assign";
        var reqParams = Object.assign({}, { inspectorId: inspectorId }, params);
        return this.construct.update(path, null, reqParams, headers);
    };
    // PUT /v4/inspections/{ ids }/assign
    // PUT https://apis.accela.com/v4/inspections/6161316/assign?inspectorId=MINSPECTOR
    InspectionApi.prototype.assignInspection = function (id, inspectorId, params, headers) {
        var path = this._basePath + "/" + id + "/assign";
        var newInspector = { inspectorId: inspectorId };
        var reqParams = Object.assign({}, params, newInspector);
        return this.construct.update(path, null, reqParams, headers);
    };
    // DELETE /v4/inspections/{ ids }/cancel
    InspectionApi.prototype.cancelInspection = function (id, params, headers) {
        return this.construct.del(this._basePath + "/" + id + "/cancel", params, headers);
    };
    InspectionApi.prototype.cancelInspections = function (ids, params, headers) {
        var args = ids.join(',');
        return this.construct.del(this._basePath + "/" + args + "/cancel", params, headers);
    };
    // POST /v4/inspections/{ id }/related
    InspectionApi.prototype.createRelatedInspection = function (id, payload, params, headers) {
        return this.construct.post(this._basePath + "/id/related", payload, params, headers);
    };
    // DELETE /v4/inspections/{ ids }
    InspectionApi.prototype.deleteInspection = function (id, params, headers) {
        return this.construct.del(this._basePath + "/" + id, params, headers);
    };
    InspectionApi.prototype.deleteInspections = function (ids, params, headers) {
        var args = ids.join(',');
        return this.construct.del(this._basePath + "/" + args, params, headers);
    };
    // DELETE /v4/inspections/{ id }/related/{ childIds }
    InspectionApi.prototype.deleteRelatedInspection = function (id, relatedIds, params, headers) {
        var childIds = relatedIds.join(',');
        return this.construct.del(this._basePath + "/" + id + "/related/" + childIds, params, headers);
    };
    // GET /v4/inspections/availableDates
    InspectionApi.prototype.getAvailableDates = function (params, headers) {
        return this.construct.get(this._basePath + "/availableDates", params, headers);
    };
    // GET /v4/inspections/{ inspectionIds }/histories
    InspectionApi.prototype.getHistoriesForInspection = function (id, params, headers) {
        return this.construct.get(this._basePath + "/" + id + "/histories", params, headers);
    };
    InspectionApi.prototype.getHistoriesForInspections = function (ids, params, headers) {
        var args = ids.join(',');
        return this.construct.get(this._basePath + "/" + args + "/histories", params, headers);
    };
    //  GET /v4/inspections/{ ids }
    InspectionApi.prototype.getInspection = function (id, params, headers) {
        return this.construct.get(this._basePath + "/" + id, params, headers);
    };
    InspectionApi.prototype.getInspections = function (ids, params, headers) {
        var args = ids.join(',');
        return this.construct.get(this._basePath + "/" + args, params, headers);
    };
    // GET /v4/inspections/{ id }/related
    InspectionApi.prototype.getRelatedInspections = function (id, params, headers) {
        return this.construct.get(this._basePath + "/" + id + "/related", params, headers);
    };
    // PUT /v4/inspections/{ id }/reschedule
    InspectionApi.prototype.reschedule = function (id, payload, params, headers) {
        return this.construct.update(this._basePath + "/" + id + "/reschedule", params, headers);
    };
    // PUT /v4/inspections/{ id }/result
    InspectionApi.prototype.result = function (id, payload, params, headers) {
        return this.construct.update(this._basePath + "/" + id + "/result", params, headers);
    };
    // POST /v4/inspections/schedule
    InspectionApi.prototype.schedule = function (payload, params, headers) {
        return this.construct.post(this._basePath + "/schedule", payload, params, headers);
    };
    // PUT /v4/inspections/{ id }/schedule
    InspectionApi.prototype.schedulePendingInspection = function (id, params, headers) {
        return this.construct.update(this._basePath + "/" + id + "/result", params, headers);
    };
    // PUT /v4/inspections/{ id }
    InspectionApi.prototype.update = function (id, payload, params, headers) {
        var path = this._basePath + "/" + id;
        return this.construct.update(path, payload, params, headers);
    };
    // GET /v4/inspections/ { inspectionId } / comments
    InspectionApi.prototype.getComments = function (id, urlParams, headers) {
        var path = this._basePath + "/" + id;
        return this.construct.get(path, urlParams, headers);
    };
    InspectionApi = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [construct_1.ConstructApi])
    ], InspectionApi);
    return InspectionApi;
}());
exports.InspectionApi = InspectionApi;
//# sourceMappingURL=inspections.js.map