import {Injectable} from '@angular/core';
import {Http, Headers, Response} from '@angular/http';
import {Observable} from 'rxjs/Observable';
import {ConstructApi} from '../construct';

@Injectable()
export class InspectionTimeAccountingApi {
  private _basePath = '/v4/inspections';

  constructor(private construct: ConstructApi) { }

  private path(inspectionId) {
    return `${this._basePath}/${inspectionId}/timeAccounting`;
  }

  get(inspectionId, urlParams?, headers?) {
    return this.construct.get(this.path(inspectionId), urlParams, headers);
  }

  updateEntry(inspectionId, entryId, body, urlParams?, headers?) {
    return this.construct.update(`${this.path(inspectionId)}/${entryId}`, body, urlParams, headers)
  }

  deleteEntry(inspectionId, entryId, urlParams?, headers?) {
    return this.construct.del(`${this.path(inspectionId)}/${entryId}`, urlParams, headers);
  }

  deleteEntries(inspectionId, entries:Array<any>, urlParams?, headers?) {
    let args = entries.join(',');
    return this.construct.del(`${this.path(inspectionId)}/${args}`, urlParams, headers);
  }

  addEntry(inspectionId, body, urlParams?, headers?) {
    return this.construct.post(this.path(inspectionId), body, urlParams, headers);
  }
}
