"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var construct_1 = require('../construct');
var RecordApi = (function () {
    function RecordApi(construct) {
        this.construct = construct;
        this._basePath = '/v4/records';
    }
    RecordApi.prototype.buildPath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (!args) {
            return this._basePath;
        }
        return this._basePath + "/" + args.join('/');
    };
    RecordApi.prototype.search = function (body) {
        return this.construct.post('/v4/search/records', body);
    };
    RecordApi.prototype.searchLocations = function (recordIds) {
        return this.construct.post('/v4/search/records/location', { ids: recordIds });
    };
    //get_records  GET /v4/records
    RecordApi.prototype.getAll = function (urlParams, headers) {
        return this.construct.get(this.buildPath(), urlParams, headers);
    };
    //get_record  GET /v4/records/{ ids }
    RecordApi.prototype.getRecord = function (id, urlParams, headers) {
        return this.construct.get(this.buildPath(id), urlParams, headers);
    };
    RecordApi.prototype.getRecords = function (ids, urlParams, headers) {
        var args = ids.join(',');
        return this.construct.get(this.buildPath(ids), urlParams, headers);
    };
    //  GET /v4/records/{recordId}/conditions
    RecordApi.prototype.getRecordConditions = function (id, urlParams, headers) {
        return this.construct.get(this.buildPath(id, 'conditions'), urlParams, headers);
    };
    // '/v4/records/' + recordId + '/partTransaction', //entry point
    RecordApi.prototype.getRecordParts = function (id, urlParams, headers) {
        return this.construct.get(this.buildPath(id, 'partTransaction'), urlParams, headers);
    };
    // 'entryPoint': '/v3/records/' + recordId + '/costs'
    RecordApi.prototype.getRecordCosts = function (id, urlParams, headers) {
        return this.construct.get("/v3/records/" + id + "/costs", urlParams, headers);
    };
    RecordApi = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [construct_1.ConstructApi])
    ], RecordApi);
    return RecordApi;
}());
exports.RecordApi = RecordApi;
//# sourceMappingURL=records.js.map