import {Injectable} from '@angular/core';
import {Http, Headers, Response} from '@angular/http';
import {Observable} from 'rxjs/Observable';
import {ConstructApi} from '../construct';

@Injectable()
export class SearchApi {
  private _basePath = '/v4/search';

  constructor(private construct: ConstructApi) { }

  // /v4/search/global?lang={lang}&query={query}&type={type}&modules={modules}&offset={offset}&limit={limit}&sort={sort}&direction={direction}
  globalSearch(urlParams, headers?) {
    return this.construct.get(`${this._basePath}/global`, urlParams, headers);
  }

  searchAgencies(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/agencies`, body, urlParams, headers);
  }

  searchAddresses(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/addresses`, body, urlParams, headers);
  }

  searchContacts(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/contacts`, body, urlParams, headers);
  }

  searchCosts(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/costs`, body, urlParams, headers);
  }

  searchInspections(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/inspections`, body, urlParams, headers);
  }

  searchOwners(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/owners`, body, urlParams, headers);
  }

  searchParcels(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/parcels`, body, urlParams, headers);
  }

  searchParts(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/parts`, body, urlParams, headers);
  }

  searchProfessionals(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/professionals`, body, urlParams, headers);
  }

  searchRecords(body, urlParams?, headers?) {
    return this.construct.post(`${this._basePath}/records`, body, urlParams, headers);
  }
}