import {Injectable} from '@angular/core';
import {Http, Headers, Response} from '@angular/http';

import {ConstructApi} from '../construct';

@Injectable()
export class SettingsInspectionsApi {
  private _basePath = '/v4/settings/inspections';

  constructor(private construct: ConstructApi) { }

  getCustomFormSettings() {}
  getCustomTableSettings() {}

  getInspectionChecklistGroups(urlParams?, headers?) {
    return this.construct.get(`${this._basePath}/checklistsGroups`, urlParams, headers);
  }

  getInspectionChecklists(urlParams?, headers?) {
    return this.construct.get(`${this._basePath}/checklists`, urlParams, headers);
  }

  getInspectionGrades(urlParams?, headers?) {
    return this.construct.get(`${this._basePath}/grades`, urlParams, headers);
  }

  getInspectionStatuses(urlParams?, headers?) {
    return this.construct.get(`${this._basePath}/statuses`, urlParams, headers);
  }

  getInspectionTypes(urlParams?, headers?) {
    return this.construct.get(`${this._basePath}/types`, urlParams, headers);
  }

  getInspectionChecklistStatuses(urlParams?, headers?) {
    return this.construct.get(`${this._basePath}/checklist/statuses`, urlParams, headers);
  }

  getInspectionChecklistsById(checklistIds:Array<any>,urlParams?, headers?) {
    let args = checklistIds.join(',');
    return this.construct.get(`${this._basePath}/checklists/${args}`, urlParams, headers);
  }

  getInspectionTypesById(typeIds:Array<any>, urlParams?, headers?) {
    let args = typeIds.join(',');
    return this.construct.get(`${this._basePath}/types/${args}`, urlParams, headers);
  }
}
