"use strict";
var core_1 = require('@angular/core');
var construct_1 = require("../src/construct");
var http_1 = require('@angular/http');
var testing_1 = require('@angular/http/testing');
var testing_2 = require('@angular/core/testing');
testing_2.describe('Construct API Tests', function () {
    testing_2.beforeEachProviders(function () {
        return [
            http_1.HTTP_PROVIDERS,
            core_1.provide(http_1.XHRBackend, { useClass: testing_1.MockBackend }),
            construct_1.ConstructApi
        ];
    });
    testing_2.it('should query the api', testing_2.inject([http_1.XHRBackend, construct_1.ConstructApi], function (mockBackend, api) {
        // first we register a mock response - when a connection 
        // comes in, we will respond by giving it an array of (one)
        // blog entries
        mockBackend.connections.subscribe(function (connection) {
            connection.mockRespond(new http_1.Response(new http_1.ResponseOptions({
                body: [
                    {
                        results: []
                    }]
            })));
        });
        // with our mock response configured, we now can 
        // ask the blog service to get our blog entries
        // and then test them
        api.get().subscribe(function (data) {
            testing_2.expect(data.results).toBeDefined();
        });
    }));
});
//# sourceMappingURL=construct.spec.js.map